<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempermintaanbarangModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempermintaanbarangService extends BaseService
{
    /**
     ItempermintaanbarangService constructor.
    */
    public function __construct()
    {
        parent::__construct();
		$this->model		= new ItempermintaanbarangModel();
		$this->stokKapal 	= new StokkapalService();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationPrNumber()->getQuery()->select(["itempermintaanbarang.id as id",
			"itemId.id as itemId",
			"prNumber.prNumber as prNumber",
			"itempermintaanbarang.needBy as needBy",
			"itempermintaanbarang.quantity as quantity",
			"itempermintaanbarang.satuan as satuan"]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempermintaanbarangModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempermintaanbarang.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempermintaanbarangModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach($newInput as $row) {
					$itemBrg = new ItempermintaanbarangModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $idx => $value) {
				$data[] = [	"prNumber"      => $input["prNumber"],
							"itemId"        => $value,
							"needBy"        => $input["needBy"][$value],
							"harga"         => intval($input["harga"][$value] *  $input["quantity"][$value]),
							"harga_satuan"  => $input["harga"][$value],
							"quantity"      => $input["quantity"][$value],
							"sisaawal"      => $this->stokKapal->getStockBasedOnItemID($input["kapalId"], $value, 0),
							"disetujui"     => 0,
                            "qtyRob"        => intval($input["qtyRob"][$value]),
                            "qtyPenggunaan" => intval($input["qtyPenggunaan"][$value]),
                            "portBunker"    => $input["portBunker"][$value]
				];
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempermintaanbarangModel
	*  @throws \Exception
	*/
	public function update($id,$input)
	{
		$itempermintaanbarang=ItempermintaanbarangModel::find($id);
		$itempermintaanbarang->fill($input);
		if(!$itempermintaanbarang->update()){
			throw new \Exception();
		}
		return $itempermintaanbarang;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}

	public function showBasedOnPermintaanbarang($request, $headerTransaction, $conditions = []) {
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationItemId("itemId")->getQuery()
		->where("itempermintaanbarang.prNumber", "=", $headerTransaction->prNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory);
		if(! empty($conditions)) {
			foreach($conditions as $condition) {
			    if($condition["operator"] == "whereIn") {
                    $this->model->getQuery()->whereIn($condition["field"], $condition["value"]);
                } else {
                    $this->model->getQuery()->where($condition["field"], $condition["operator"], $condition["value"]);
                }
			}
		}
		$model = $this->model->getQuery()->select(["itempermintaanbarang.id as id",
					"itempermintaanbarang.itemId",
					"itemId.namaItem as namaItem",
					"itemId.part_number as partNumber",
					"itemId.deskripsi as deskripsi",
					"itempermintaanbarang.harga",
					"itempermintaanbarang.harga_satuan",
					"itempermintaanbarang.sisaawal",
					"itempermintaanbarang.disetujui",
                    "itempermintaanbarang.qtyRob",
                    "itempermintaanbarang.qtyPenggunaan",
                    "itempermintaanbarang.portBunker",
					"itemCategory.category as category",
					"itemId.UOM as UOM",
					"itemId.destination_type_code",
					"itempermintaanbarang.quantity as quantity",
					"itempermintaanbarang.needBy as needBy"])->get();
		return $model;
	}
}